c       If Fortran had data structures and pointers they would be used here.
C       ================================================================
C       A common block of information about the location of the cursor.
C       When each locator event (keystroke in crosshair mode or mouse click)
C       is received, the elements of this common block are updated to reflect
C       the location.
C       ================================================================
c       There are no variables associated with the buttons
C       ================================================================
c       Extreme care must be taken with these pointers to insure that
c       the data in the equivalence do not overlap.
	integer         i_bmenus
	integer         i_optics
	integer         i_allset
	integer         i_dewar
	integer         i_defset
	integer         i_refresh
	integer         i_zoom
	integer         i_quit2com
	integer         i_escape
	integer         i_dispord
	integer         i_displam
	integer         i_markdet
	integer         i_linepos
	integer         i_kicsset
	parameter       (i_bmenus   =  0)
	parameter       (i_optics   =  i_bmenus   + 1)
	parameter       (i_allset   =  i_optics   + 1)
	parameter       (i_dewar    =  i_allset   + 1)
	parameter       (i_defset   =  i_dewar    + 1)
	parameter       (i_refresh  =  i_defset   + 1)
	parameter       (i_zoom     =  i_refresh  + 1)
	parameter       (i_quit2com =  i_zoom     + 1)
	parameter       (i_escape   =  i_quit2com + 1)
	parameter       (i_dispord  =  i_escape   + 1)
	parameter       (i_displam  =  i_dispord  + 1)
	parameter       (i_markdet  =  i_displam  + 1)
	parameter       (i_linepos  =  i_markdet  + 1)
	parameter       (i_kicsset  =  i_linepos  + 1)
C       ----------------------------------------------------------------
c                       lower limit of array of menu entries
	integer         MINBDATA
	parameter       (MINBDATA = i_bmenus)
c                       upper limit of array of menu entries
	integer         MAXBDATA
	parameter       (MAXBDATA = i_kicsset)
c                       bogus pointer value
	integer         NULBDATA
	parameter       (NULBDATA = MINBDATA - 1)
C       ================================================================
c                       equivalence to all of the above
	real            bdatar(MINBDATA:MAXBDATA)
	integer         bdatai(MINBDATA:MAXBDATA)
	equivalence     (bdatar, bdatai)
c                       some items come with accelerator keys
c                       that allow their values to be changed.
	character*1     bdataa(MINBDATA:MAXBDATA)
c                       pointers telling which ones to actually display
c                       and in what order to display them
c                       if the pointer value is NULBDATA, it is skipped
	integer         bdatap(MINBDATA:MAXBDATA)
c                       format to use to display each value
	character       bdataf(MINBDATA:MAXBDATA)*(14)
c                       character strings to use to display label strings
	character       bdatal(MINBDATA:MAXBDATA)*(LLABSTR)
c                       character strings to use to display value strings
	character       bdatav(SVOLD:SVNEW,MINBDATA:MAXBDATA)*(LVALSTR)
c                       positions of the labels in Normalized Device Coords
	real            bdatax(Xp:Yp,MINBDATA:MAXBDATA,2)
C       ----------------------------------------------------------------
cccccc  equivalence     (clambda , bdatar(i_clambda))
C       ----------------------------------------------------------------
c                       is this menu currently displayed?
	logical         bdataup
c                       is this menu currently displayed?
	logical         bmeninit
c                       NDC y limits of this menu
	real            bminndc
	real            bmaxndc
c                       bottom entry to be displayed
	integer         botbdata
C       ----------------------------------------------------------------
	common  /button/
     &          bdatar, bdatap, bminndc, bmaxndc, bdatax,
     &          botbdata,
     &          bdataup, bmeninit
	common  /buttonstr/      bdataf, bdatal, bdatav, bdataa
