;  Quick function to use to return pgplot library
;  If you want it to search again, empty environment variable with
;    IDL> setenv,'SHELL=/bin/sh'
;    IDL> setenv,'IDLPGPLOT='
;
;  If you want to override the search, just setenv to the correct
;  library before the first call to findpgplot
;

pro findpgplot, libraryname

   if getenv('IDLPGPLOT') NE '' then return

   if NOT keyword_set(libraryname) then libraryname='libpgplot.so'

   wildname = libraryname+'*'

   ; first make list of directories. 

   cd, '.', current=current
   dirlist = [current, getenv('PGPLOT_DIR'), $
                   str_sep(getenv('LD_LIBRARY_PATH'),':')]

   for i=0, n_elements(dirlist) - 1 do begin
     dir = dirlist[i]
     ff = findfile(filepath(wildname,root_dir=dir),count=count)
     for j = 0, count -1 do begin
       spawn, 'nm -v '+ff[j]+' | grep idl', ans
       if ans[0] NE '' then begin
         sh = getenv('SHELL')
         setenv,'SHELL=/bin/sh'
         setenv,'IDLPGPLOT='+ff[j]
         setenv,'SHELL='+sh
         return
       endif
     endfor
   endfor

   print, 'Can not find the pgplot shared library with IDL enhancements'
   print, 'I looked in these directories: ', dirlist
   print, 'For this filename: ', wildname

   return
end

