#include "include/port.h"
C==============================================================================
C==============================================================================
	integer function keymouse()
c       Catch keyboard and mouse events and process them
c       This is the main_loop in which the user spends the most time
c       interacting with the program.
	IMPLICIT_NONE
C       Parameters
#       include "include/stdio.par"
#       include "echelle.par"
#       include "include/units.par"
c                       Lick Mongo LVISIBILITY mode
	integer         INVERT
	parameter       (INVERT = 2)
c                       ISI Mouse button codes
	integer         ISIMB1
	parameter       (ISIMB1 = 40209)
	integer         ISIMB2
	parameter       (ISIMB2 = 40210)
	integer         ISIMB3
	parameter       (ISIMB3 = 40212)
c                       X11 Mouse button codes
	integer         X11MB1
	parameter       (X11MB1 = -1)
	integer         X11MB2
	parameter       (X11MB2 = -2)
	integer         X11MB3
	parameter       (X11MB3 = -3)
C       Local Variables
c                       loops
	integer         i, imos
c                       a temporary logical variable
	logical         okay
c                       current & saved positions of cursor (Echelle ) [mm]
	real            xeurs, yeurs
c                       current positions of cursor (Lick Mongo coords) [mm]
	real            xcurs, ycurs
c                       a dummy variable for temporary use
	real            tmpdum, reldist
c                       the character typed in cursor mode
	character*1     comm
c                       ASCII code of character typed in cursor mode
	integer         key, keylast
c                       label identifying the new changeable parameter
	character       newlab*(LLABEL)
c                       an input string typed by a user
	character*80    stringinp
c                       corners of a box being tracked [mm]
	real            tx0, ty0, tx1, ty1
c                       this might have been in the setup.inc common block
c                       but is is not.  It is the tilt of the Hamilton
c                       Echelle grating measured in encoder units.
	real            egtilt
	character*80    title1,title2
C       External Functions
c                       a function which gets unambiguous input
	logical         getyes
c                       Lick Mongo function which gets non-blank string length
	integer         PMGO(lenc)
c                       Lick Mongo X11 function which registers an event handler
c       integer         PTUV(regmot)
c                       subroutine which acts as an event handler
	external        xtrackcur
c                       find the spectral line nearest to the cursor
	integer         findline
c
	logical         acspgraf
	logical         acsetup
c       logical         acdetmos
	logical         acbutton
	logical         trspgraf
	logical         trsetup
c       logical         trdetmos
c       logical         wbcdata
	logical         wbspgraf
	logical         wbsetup
c       logical         wbdetmos
	logical         wbbutton
C       Common Blocks
	include 'echord.cmn'
	include 'lam.cmn'
	include 'spgraf.inc'
	include 'wizard.cmn'
	include 'cdata.inc'
	include 'lims.cmn'
	include 'linpos.cmn'
	include 'detmos.inc'
	include 'setup.inc'
	include 'button.inc'
C       Data
	data    newlab  /'       '/
c       initial values of Hamilton Spectrograph height and tilt parameters
c       egt(0)= echelle grating tilt reading when blaze in center of CCD
c       egt(1)= change in tilt reading with motion of 1 mm at chip
C       data    egt     /494000., -78./ before 1988 Dec 24
	data    egt     /493743., -76.4/
c       hgt(0)= CCD height reading when order # 120 in center of CCD
c       hgt(1)= change in height reading with motion of 1 mm at chip
C       data    hgt     /501302., 570./ before 1988 Dec 24
	data    hgt     /500605., 601./
C       Executable Code
	keymouse = 0
	tilt = .true.
c       top of interaction loop, we keep jumping back to here
100     continue
c       on a Sun, check to see if the last action caused IEEE exception
c	call sunieee()
c       wait for user action (key or mouse button press)
	call mongohairs(key,xcurs,ycurs)
c       convert Mongo coordinates to Echelle coordinates
	xeurs = xcurs
	yeurs = ycurs
	call translate(xeurs, yeurs, tde(Xp,Xo,D2E), 1)
c       redisplay position of crosshair info about format at that point
	call cursdata(yeurs,xeurs)
	call detcoord(xcurs,ycurs,idet,dpx,dpy)
	call udcdata
	call udsetup
c       convert the integer to equivalent ASCII character
	comm = char(key)
c       convert the ASCII character to uppercase
	if (comm .ge. 'a' .and. comm .le. 'z')
     &  comm = char(ichar(comm) - 32)
c       figure out what to do
c       ----------------------------------------------------------------
	if (acbutton(comm,i) .or.
     &  (key .eq. X11MB1 .and. wbbutton(xcurs,ycurs,i))) then
c           this key is one of the accelerators for changing the
c           list of menus being displayed
c           or the user clicked MB1 on its label
	    if (i .eq. i_quit2com .or. i .eq. i_escape) then
c               quit the interactive cursor and go to command mode
		call tidle
		goto 9900
	    elseif (i .eq. i_defset) then
c               display only the usual cursor/setup information
		call dnspgraf
		call dndetmos
		call upbutton
		call upcdata
		call rasetup(0)
		call upsetup
	    elseif (i .eq. i_optics) then
c               display all the telescope/spectrograph optical hardware information
		call dnsetup
		call dncdata
		call dndetmos
		call upspgraf
	    elseif (i .eq. i_allset) then
c               display all the setup information
		call dnspgraf
		call dncdata
		call dndetmos
		call rasetup(1)
		call upsetup
	    elseif (i .eq. i_dewar) then
c               display all the detector mosaic information
		call dnspgraf
		call dncdata
		call dnsetup
		call radetmos(0)
		call updetmos
	    elseif (i .eq. i_refresh) then
c               Pack in new values of everything and re-plot
c               It is essential to forget the saved positions, because
c               they are expressed in a coordinate system which no longer
c               means anything.
		nmos = 0
		call dndetmos
		call dncdata
		call dnsetup
		call dnspgraf
		call dnbutton
		goto 9000
	    elseif (i .eq. i_zoom) then
		if (.not. fulform) then
c                   we are already zoomed, unzoom
		    fulform = .true.
		    goto 9000
		endif
c               zoom in to show only the region inside the CCD
		fulform = .false.
c               this ignores any rotation between detector and format
C               define DEBUGZOOM
#               ifdef DEBUGZOOM
		write(STDERR,*) '-Xposmos,tx01',
     &          posmos(Xp,0),tx0,tx1
		write(STDERR,*) '-Yposmos,ty01',
     &          posmos(Yp,0),ty0,ty1
#               endif /* DEBUGZOOM */
c               tx0 and ty0 become the margin around the edge of the detector
		tx0 = (cormos(Xp,2) - cormos(Xp,1)) * (PMARGIN - 1) * .5
		ty0 = (cormos(Yp,2) - cormos(Yp,1)) * (PMARGIN - 1) * .5
		xmin = posmos(Xp,0) + cormos(Xp,1) - tx0
		xmax = posmos(Xp,0) + cormos(Xp,2) + tx0
		if (nxdgrat .gt. 0) then
c                   Note that when the format is redrawn, the current y position
c                   of the center of the mosaic will be at coordinate 0.
c                   Thus, we do not use posmos(Yp,0) in this calculation.
		    ymin = cormos(Yp,1) - ty0
		    ymax = cormos(Yp,2) + ty0
		else
c                   when there are only prisms, the coordinates do not shift
		    ymin = posmos(Yp,0) + cormos(Yp,1) - ty0
		    ymax = posmos(Yp,0) + cormos(Yp,2) + ty0
		endif
#               ifdef DEBUGZOOM
		write(STDERR,*) '+Xposmos,tx01',
     &          posmos(Xp,0),tx0,tx1
		write(STDERR,*) '+Yposmos,ty01',
     &          posmos(Yp,0),ty0,ty1
#               endif /* DEBUGZOOM */
c               If the observing site uses non-standard video orientation,
c               exchange the Lick Mongo coordinates to flip the entire picture.
		if (.not. stdvidv) then
		    tmpdum = ymin
		    ymin = ymax
		    ymax = tmpdum
		endif
		if (.not. stdvidh) then
		    tmpdum = xmin
		    xmin = xmax
		    xmax = tmpdum
		endif
		goto 9000
	    elseif (i .eq. i_displam) then
c               plot/unplot the wavelengths of the orders
		call plotmord(2,mci)
		lamnum = .not. lamnum
		call plotmord(2,mci)
	    elseif (i .eq. i_dispord) then
c               plot/unplot the order numbers of the orders
		call plotmord(2,mci)
		ordnum = .not. ordnum
		if (ordnum) lamnum = .false.
		call plotmord(2,mci)
	    elseif (i .eq. i_markdet) then
c               plot a semi-permanent box on top of the moveable box.
c               Box size is same as the detector mosaic.
		imos = 0
		reldist = RELDMIN
		do 500 i=1,nmos
c                 find out which of the already placed detectors is closest
		  tmpdum = ( (posmos(Xp,i) - posmos(Xp,0)) /
     &            (cormos(Xp,2) - cormos(Xp,1)) )**2
     &            +        ( (posmos(Yp,i) - posmos(Yp,0)) /
     &            (cormos(Yp,2) - cormos(Yp,1)) )**2
		  if (tmpdum .lt. reldist) then
		      imos = i
		      reldist = tmpdum
		  endif
500             continue
		if (imos .ne. 0) then
c                   there was a previous box close to the current location
c                   undraw this box and move last box into its position
		    call mosaic(imos,INVERT)
		    call badcol(imos,INVERT)
c                   call drowins(INVERT)
		    posmos(Xp,imos) = posmos(Xp,nmos)
		    posmos(Yp,imos) = posmos(Yp,nmos)
		    nmos = nmos - 1
		elseif (nmos .lt. MAXMOSPOS) then
c                   a new position is saved for posterity
		    nmos = nmos + 1
		    posmos(Xp,nmos) = posmos(Xp,0)
		    posmos(Yp,nmos) = posmos(Yp,0)
		    call mosaic(nmos,INVERT)
		    call badcol(nmos,INVERT)
c                   call drowins(INVERT)
		endif
c               write(STDERR,*) 'nmos ',nmos
c               call sunieee()
c               write(STDERR,*) 'posmos',posmos(Xp,nmos),posmos(Yp,nmos)
	    elseif(i .eq. i_linepos) then
635             continue
		title1 = 'Enter name for line position dump:  '
		i = PMGO(lenc)(title1) + 2
		call mgoprompt(title1(:i))
		call mx11gets(title2)
		if (title2 .eq. ' ') then
		    if (setup .eq. ' ') goto 635
		else
		    setup = title2
		endif
c               write out the setup in this directory
		call linepos(title2)
	    elseif(i .eq. i_kicsset) then
640             continue
		i = PMGO(lenc)(setup)
		title1 =
     &          'Enter a name for this setup ('//setup(:i)//'):  '
		i = PMGO(lenc)(title1) + 2
		call mgoprompt(title1(:i))
		call mx11gets(title2)
		if (title2 .eq. ' ') then
		    if (setup .eq. ' ') goto 640
		else
		    setup = title2
		endif
c               write out the setup in this directory
		call wkics(' ')
		i = PMGO(lenc)(setup)
		call writset(setup(:i)//'.set')
		call mgoprompt('Do you want to execute this setup?  ')
		if (getyes(i)) then
c                   make a copy of the setup in the real directory
		    call wkics(KSETUPDIR)
		    call mgoprompt('Are you sure?  ')
		    if (getyes(i)) then
c                       execute the setup
			call system('go -f '//setup)
		    endif
		endif
	    endif /* i .eq. i_something */
c       --------------------------------
	elseif (acspgraf(comm,i) .or.
     &  (key .eq. X11MB1 .and. wbspgraf(xcurs,ycurs,i))) then
c           this key is one of the accelerators for changing the
c           design of telescope or spectrograph.
c           or the user clicked MB1 on its label
	    if (.not. idataup) then
		call dndetmos
		call dncdata
		call dnsetup
		call upspgraf
	    endif
	    if (wizard) then
		call mgoprompt('New value for '//idatal(i))
		call mx11gets(stringinp)
		if (trspgraf(stringinp,i)) then
		    if ( (i .eq. i_PRAPEXD ) .or. (i .eq. i_PRGLAS  )
     &              .or. (i .eq. i_PRFACE  ) .or. (i .eq. i_NXDPRISM)
     &              ) then
c                       set new values for all of the prisms
			call newprism(i)
c                   elseif (i .eq. i_XDDELTA) then
c                       get the degree version also
c                       xddeltad = xddelta * degPERrad
		    elseif (i .eq. i_XDDELTAD) then
c                       get the radian version also
c                       xddelta = xddeltad * radPERdeg
		    elseif (i .eq. i_ECDELTA) then
c                       get the degree version also
			ecdeltad = ecdelta * degPERrad
		    elseif (i .eq. i_ECDELTAD) then
c                       get the radian version also
			ecdelta = ecdeltad * radPERdeg
		    elseif (i .eq. i_ECTHETA) then
c                       get the degree version also
			ecthetad = ectheta * degPERrad
		    elseif (i .eq. i_ECTHETAD) then
c                       get the radian version also
			ectheta = ecthetad * radPERdeg
		    elseif (i .eq. i_ECSIGMAI) then
c                       respect spacing constraints
			if (fixspace) then
			    ecsigmai = HeNeWAV * umPERAang *
     &                      nint((ecsigmai*AangPERum)/HeNeWAV)
			endif
			ecsigma = umPERmm / ecsigmai
		    elseif (i .eq. i_ECSIGMA) then
c                       respect spacing constraints
			ecsigmai = umPERmm / ecsigma
			if (fixspace) then
			    ecsigmai = HeNeWAV * umPERAang *
     &                      nint((ecsigmai*AangPERum)/HeNeWAV)
			    ecsigma = umPERmm / ecsigmai
			endif
		    elseif (i .eq. i_XDSIGMAI) then
			xdsigma = umPERmm / xdsigmai
		    elseif (i .eq. i_XDSIGMA) then
			xdsigmai = umPERmm / xdsigma
		    elseif ( i .eq. i_COLFOCLN) then
			collmeth = i_COLFOCLN
c                       recalculate the collimated beam diameter
			colldiam = (mmPERm / asecPERrad) *
     &                  (colfocln * primdiam * focscale)
		    elseif ( i .eq. i_COLLDIAM)  then
			collmeth = i_COLLDIAM
c                       recalculate the collimator focal length
			colfocln = (asecPERrad / mmPERm) *
     &                  (colldiam / (primdiam * focscale))
		    elseif ((i .eq. i_FOCSCALE) .or. (i .eq. i_PRIMDIAM)
     &              ) then
			if     (collmeth .eq. i_COLLDIAM) then
			    colfocln = (asecPERrad / mmPERm) *
     &                      (colldiam / (primdiam * focscale))
			elseif (collmeth .eq. i_COLFOCLN) then
			    colldiam = (mmPERm / asecPERrad) *
     &                      (colfocln * primdiam * focscale)
			endif
		    elseif (i .eq. i_NXDGRAT) then
c                       the code does not allow for a change here
			nxdgrat = 1
		    elseif ((i .eq. i_TELESCOP) .or. (i .eq. i_INSTRUME)
     &              .or.    (i .eq. i_CAMFOCLN) .or. (i .eq. i_XDALFBET)
     &              .or.    (i .eq. i_FPROTANG) .or. (i .eq. i_PRANGIND)
     &              ) then
c                       the trspgraf routine has changed the appropriate value
c                       and no further action is required
		    else
			write(STDERR,*)
     &                  'Cannot reset spgraf item ', idatal(i)
		    endif /* (i .eq. i_XXXXXX) */
		endif /* trspgraf(stringinp,i) */
c               most changes to the above variables require a replot ...
		call dnspgraf
		call dnbutton
c               ... for that reason, we erase the echelle format
		call PMGO(erase)()
		call upspgraf
		call upbutton
	    else  /* wizard */
		if (i .eq. i_wizard) then
c                   see if user is a wizard
		    call tidle
		    call mgoprompt(' Are you a wizard?  ')
		    call mx11gets(stringinp)
		    wizard = stringinp(1:1) .eq. 'y'
		    if (wizard) then
			call mgoprompt(' Prove it:  ')
			call mx11gets(stringinp)
			wizard = stringinp(1:4) .eq. 'Vogt'
			if (wizard) then
			    call mgoprompt(' Regards to the wizard!')
			else
			    call mgoprompt(' You are not a wizard.')
			endif
		    endif
		else
		    call mgoprompt('Only Wizards can change optics')
		endif
	    endif /* wizard */
c       --------------------------------
	elseif (acsetup(comm,i) .or.
     &  (key .eq. X11MB1 .and. wbsetup(xcurs,ycurs,i))) then
c           this key is one of the accelerators for changing the
c           setup of detector or spectrograph.
	    call dncdata
	    call dnspgraf
	    call upsetup
	    call mgoprompt('New value for '//sdatal(i))
	    call mx11gets(stringinp)
	    if (trsetup(stringinp,i)) then
		if     ((i .eq. i_SLITVEL ) .or. (i .eq. i_SLITPIX)
     &          .or.    (i .eq. i_SLITSIZE) .or. (i .eq. i_SLITRAW)
     &          .or.    (i .eq. i_SLITWID )) then
		    slitmeth = i
		    call calcslit
		elseif ((i .eq. i_DECKPIX ) .or. (i .eq. i_DECKSIZE)
     &          .or.    (i .eq. i_DECKHGT )) then
		    deckmeth = i
		    call calcdeck
		elseif ((i .eq. i_XDANGLE ) .or. (i .eq. i_ECANGLE )
     &          .or.    (i .eq. i_XDALPHAD) .or. (i .eq. i_HAMHGT  )
     &          ) then
		    if (i .eq. i_XDALPHAD) xdangle =
     &              xdalphad - (xddeltad + xdalfbet*0.5)
c                   the move is done, undraw the old location of the detector
		    call mosaic(0,INVERT)
		    call badcol(0,INVERT)
		    call drowins(INVERT)
c                   calculate new position of detector
		    call spc2det
c                   draw the new location of the detector
		    call mosaic(0,INVERT)
		    call badcol(0,INVERT)
		    call drowins(INVERT)
		elseif (i .eq. i_RADVEL  ) then
		    redshift =
     &              sqrt((1+radvel/cLIGHT)/(1-radvel/cLIGHT)) - 1
		    radvelz = redshift
		elseif (i .eq. i_RADVELZ ) then
		    redshift = radvelz
		    radvel = cLIGHT *
     &              (((1+redshift)**2 - 1) / ((1+redshift)**2 + 1))
		elseif ((i .eq. i_COLL    ) .or. (i .eq. i_CAMERA  )
     &          ) then
c                   COLL and CAMERA can only be 'RED' or 'BLUE'
		    if     ( sdatav(SVNEW,i)(1:1) .eq. 'R'
     &              .or.     sdatav(SVNEW,i)(1:1) .eq. 'r' ) then
			sdatav(SVNEW,i) = 'RED'
		    elseif ( sdatav(SVNEW,i)(1:1) .eq. 'B'
     &              .or.     sdatav(SVNEW,i)(1:1) .eq. 'b' ) then
			sdatav(SVNEW,i) = 'BLUE'
		    else
c                       reset back to the original value
			sdatav(SVNEW,i) = sdatav(SVOLD,i)
			call mgoprompt('Value must be RED or BLUE')
		    endif
		elseif ((i .eq. i_FILTER  ) .or. (i .eq. i_FILTER2 )
     &          ) then
		    if ( sdatai(i) .lt. 1 .or. sdatai(i) .gt. 12 ) then
			sdatai(i) = min(12,max(1,sdatai(i)))
			call mgoprompt('Filter must be from 1 to 12')
		    endif
		elseif ((i .eq. i_XBIN    ) .or. (i .eq. i_YBIN    )
     &          ) then
		    if ( sdatai(i) .lt. 1) then
			sdatai(i) = 1
			call mgoprompt('Binning must >= 1')
		    endif
		elseif ((i .eq. i_WAVFILNM)
     &          ) then
c                   read a new wavelength file
		    call getwave()
		elseif ((i .eq. i_COFOCUS ) .or. (i .eq. i_CAFOCUS )
     &          .or.    (i .eq. i_SETUPNM ) .or. (i .eq. i_OBSERVER)
     &          .or.    (i .eq. i_FILNAME ) .or. (i .eq. i_FIL2NAME)
     &          .or.    (i .eq. i_XDORDER ) .or. (i .eq. i_DECKNNAM)
     &          .or.    (i .eq. i_WAVLMAX ) .or. (i .eq. i_WAVLMIN )
     &          .or.    (i .eq. i_RADVEL  ) .or. (i .eq. i_RADVELZ )
     &          ) then
c                   the trsetup routine has changed the appropriate value
c                   and no further action is required
		else
		    write(STDERR,*)
     &              'Cannot reset setup item ', sdatal(i)
		endif /* (i .eq. i_XXXXXX) */
c               --------
		if ( (i .eq. i_XDORDER )
     &          .or. (i .eq. i_WAVLMAX ) .or. (i .eq. i_WAVLMIN )
     &          .or. (i .eq. i_RADVEL  ) .or. (i .eq. i_RADVELZ )
     &          ) then
c                   we really must redraw everything
		    call PMGO(erase)()
		endif
	    endif
	    call dnsetup
	    call upsetup
	    call upbutton
c       ----------------------------------------------------------------
	elseif (key .eq. X11MB1 .or. key .eq. 9) then
Cmkey       Button1:  try to identify the spectral line nearest to cursor
Cmkey       ^I:       try to identify the spectral line nearest to cursor
	    if (findline(xeurs,yeurs,i) .eq. SUCCESS) then
		if (earth(i)) then
		    write(stringinp,*) 'Wavelength ', lambda(i)
		else
		    write(stringinp,*) 'Wavelength ', lambda(i),
     &              ' at redshift ', redshift
		endif
	    else
		stringinp = 'Cannot find a spectral line'
	    endif
	    call mgoprompt(stringinp)
	elseif (key .eq. X11MB3 .or. comm .eq. 'W') then
Cmkey       W:  pretend there is a mouse, and define a readout window
Cmkey       Button3:  use mouse to move a readout window over the format
	    tx0 = xcurs
	    ty0 = ycurs
	    tx1 = xcurs
	    ty1 = ycurs
	    call trkrbox(key,tx0,ty0,tx1,ty1,okay)
	    if (okay) then
		call drowins(INVERT)
		call rowind(tx0,ty0,tx1,ty1)
		call drowins(INVERT)
	    endif
	elseif (key .eq. X11MB2 .or. comm .eq. 'M') then
Cmkey       M:  pretend there is a mouse, and move a CCD over the format
Cmkey       Button2:  use mouse to move a CCD over the format
c           add the offset coord of each corner to the position of mosaic
	    tx0 = cormos(Xp,1) + posmos(Xp,0)
	    ty0 = cormos(Yp,1) + posmos(Yp,0)
	    tx1 = cormos(Xp,2) + posmos(Xp,0)
	    ty1 = cormos(Yp,2) + posmos(Yp,0)
c           we might want to turn tracking off while moving box
c           i = PTUV(regmot)(0,0)
c           do the magical moving of a box using the mouse
	    call trkfbox(key, xcurs,ycurs, tx0,ty0, tx1,ty1)
c           if we turned tracking off, we want it back on now
c           i = PTUV(regmot)(1,xtrackcur)
c           the move is done, undraw the old location of the detector
	    call mosaic(0,INVERT)
	    call badcol(0,INVERT)
	    call drowins(INVERT)
c           (origin of mosaic) = (middle of rectangle) - (coord of middle)
	    posmos(Xp,0) = 0.5 * (tx0 + tx1) - cormos(Xp,0)
	    posmos(Yp,0) = 0.5 * (ty0 + ty1) - cormos(Yp,0)
#           ifdef DEBUGZOOM
	    write(STDERR,*) ' Xposmos,tx01',
     &      posmos(Xp,0),tx0,tx1
	    write(STDERR,*) ' Yposmos,ty01',
     &      posmos(Yp,0),ty0,ty1
#           endif /* DEBUGZOOM */
c           reset coordinate transformations for the new location
	    call distran
c           draw the new location of the detector
	    call mosaic(0,INVERT)
	    call badcol(0,INVERT)
	    call drowins(INVERT)
c           calculate the spectrograph configuration implied by this position
	    call det2spc(egtilt)
c           write out these changes
	    call udsetup
c       ----------------------------------------------------------------
	else
c           no defined action, do nothing
	endif
c       ----------------------------------------------------------------
	xclast = xeurs
	yclast = yeurs
	keylast = key
	goto 100
C       End of Keyboard and mouse event processing block
9000    continue
c       set return value so that entire picture gets redrawn
	keymouse = -1
9900    continue
	call tidle
	return
	end
C=======================================================================
C=======================================================================
	integer function comloop()
	IMPLICIT_NONE
C       Parameters      ------------------------------------------------
#       include "include/stdio.par"
#       include "echelle.par"
C       External Variables
C       Local Variables ------------------------------------------------
c                       string from user to use as title on hardcopy plots
	character*132   title
c                       string from user to use as name of PostScript file
	character*132   psfile
c                       a help menu for the user
	character*72    prompts(12)
c                       the character typed by the user
	character*1     comm
c                       loop
	integer         i
C       External Functions
	integer         dohardplot
c                       Lick Mongo function
	integer         PMGO(lenc)
c                       a function which gets unambiguous input
	logical         getyes
C       Common Blocks   ------------------------------------------------
	include 'spgraf.inc'
	include 'lims.cmn'
	include 'setup.inc'
	include 'lam.cmn'
C       Data            ------------------------------------------------
	data    (prompts(i),i=1,10) /
     1  ' Non-plot commands are as follows:',
     2  '   W: Write format.out file describing Echelle format',
     3  '   G: Go back to start and refresh all echelle parameters',
     4  '   L: Make a laser plot',
     5  '   P: Make a PostScript file',
     6  '   R: Refresh plot and return to Interaction with plot',
     7  '   M: Minimize deviations of lines from blaze wavelength',
     8  '   Q: Quit the program',
     9  '   I: return to Interaction with plot',
     A  '   K: Define a KICS setup'/
	data    (prompts(i),i=11,12) /
     1  ' ',
     2  'Hit return in this text window when done'/
C       Executable Code ------------------------------------------------
	comloop = -1
620     continue
	call mgoprompt('Command (? for help):  ')
	call mx11gets(comm)
	if (comm .ge. 'a' .and. comm .le. 'z')
     &  comm = char(ichar(comm) - 32)
	if (comm .eq. 'W') then
c           Write out a file containing a description of the echelle format
	    call writform
	elseif(comm .eq. 'G') then
c           complete restart of program
	    boxfl = .true.
	    comloop = 1
	elseif(comm .eq. 'L' .or. comm .eq. 'P') then
	    title = ' '
	    call mgoprompt('Enter a label for this plot:  ')
	    call mx11gets(title)
	    psfile = ' '
	    if (comm .eq. 'P') then
		call mgoprompt('Enter name of the output PS file:  ')
		call mx11gets(psfile)
	    endif
	    i = dohardplot(title,psfile)
	    call device(idev)
	elseif(comm .eq. 'K') then
c           define and execute a KICS setup
640         continue
	    i = PMGO(lenc)(setup)
	    title = 'Enter a name for this setup ('//setup(:i)//'):  '
	    i = PMGO(lenc)(title) + 2
	    call mgoprompt(title(:i))
	    call mx11gets(title)
	    if (title .eq. ' ') then
		if (setup .eq. ' ') goto 640
	    else
		setup = title
	    endif
c           write out the setup in this directory
	    call wkics(' ')
	    i = PMGO(lenc)(setup)
	    call writset(setup(:i)//'.set')
	    call mgoprompt('Do you want to execute this setup?  ')
	    if (getyes(i)) then
c               make a copy of the setup in the real directory
		call wkics(KSETUPDIR)
		call mgoprompt('Are you sure?  ')
		if (getyes(i)) then
c                   execute the setup
		    call system('go -f '//setup)
		endif
	    endif
	elseif(comm .eq. 'I') then
c           return to interaction with plot
	    comloop = 1000
	elseif(comm .eq. 'R') then
c           refresh plot and return to interaction
	    boxfl = .true.
	    fulform = .true.
	    comloop = 100
	elseif(comm .eq. 'M') then
	    call minimize(ecsigmai,ecthetad,ecdeltad)
	    boxfl = .true.
	    fulform = .true.
	    comloop = 100
	elseif(comm .eq. '?' .or. comm .eq. 'H') then
	    call mgoprompt('Look at the text screen')
	    write(STDOUT,ALINE) prompts
	    read(STDIN,*)
	elseif(comm .eq. 'Q') then
	    return
	else
	    call mgoprompt(' Unknown command. Use ? or H for help.')
	endif
	if (comloop .lt. 0) goto 620
	return
	end
C=======================================================================
C=======================================================================
	integer function dohardplot(title,psfile)
	IMPLICIT_NONE
C       Parameters      ------------------------------------------------
#       include "include/stdio.par"
#       include "echelle.par"
c                       Lick Mongo LVISIBILITY mode
	integer         INVERT
	parameter       (INVERT = 2)
C       External Variables
c                       string from user to use as title on hardcopy plots
	character*(*)   title
c                       string from user to use as name of PostScript file
	character*(*)   psfile
C       Local Variables ------------------------------------------------
c                       loop
	integer         i
C       External Functions
c                       two Lick Mongo functions
	integer         PMGO(fileplot)
	integer         PMGO(lenc)
C       Common Blocks   ------------------------------------------------
	include 'spgraf.inc'
	include 'lims.cmn'
	include 'setup.inc'
	include 'lam.cmn'
C       Executable Code ------------------------------------------------
c       dump a hardcopy plot to the laserprinter
#       ifdef IMAGEN
	call imsetup
	call fileinit
	call setlweight(1.)
#       else /* IMAGEN */
	call psplot(.true.,psfile,' ')
	call setlweight(0.3)
	call setpsfmode(2)
	call makecolor(2,.6,.6,.6)
c       call makecolor(3,0.,0.,0.)
c       call makecolor(4,0.,0.,0.)
c       call makecolor(5,0.,0.,0.)
#       endif /* IMAGEN */
c       set up the geometric transformation
	call getphysical(pxmin,pymin,pxmax,pymax)
	call setlim(xmin,ymin,xmax,ymax)
	call rect(-1,-1,-1,-1)
c       plot the echelle orders
	call setexpand(0.7)
	call plotmord(0,mci)
c       plot any ccd mosaics
	do 630 i = 1,nmos
	  call mosaic(i,INVERT)
	  call badcol(i,INVERT)
630     continue
	call rect(1,2,0,0)
	call setexpand(0.3)
	if (nlam .gt. 0) call marklines(.true.)
	call setexpand(1.)
	call xlabel(4,'[mm]')
	call ylabel(4,'[mm]')
	call tlabel(PMGO(lenc)(title),title)
	write(STDOUT,*) PMGO(fileplot)(0),' vectors plotted'
	return
	end
C=======================================================================
C=======================================================================
	subroutine xtrackcur(xd, yd, wx, wy)
c       as the cursor moves across the echelle format, update values
c       this serves as a Lick Mongo X11 event handler callback routine
	IMPLICIT_NONE
C       Parameters
#       include "echelle.par"
C       External Variables
c                       Lick Mongo device coordinates of event
	integer         xd, yd
c                       Lick Mongo world coordinates of event
	real            wx, wy
C       Internal Variables
c                       local copy of world coords
	real            lwx, lwy
C       Common Block
	include 'setup.inc'
	include 'cdata.inc'
C       Executable Code
	lwx = wx
	lwy = wy
	call translate(lwx,lwy,tde(Xp,Xo,D2E),1)
	call cursdata(lwy, lwx)
	call detcoord(wx, wy, idet, dpx, dpy)
	call udcdata()
	return
	end
C=======================================================================
C=======================================================================
	subroutine rowind(tx0,ty0,tx1,ty1)
c       Given Echelle Format coordinates of 2 points
c       find the corresponding readout windows on each detector.
c       These windows are loaded into the setup common block.
c       Limits are computed and stored as if binning were 1,
c       binning is only taken into account when drawing pictures.
C       Parameters
#       include "echelle.par"
#       include "include/units.par"
C       External Variables
c                       Echelle Format coordinates of one corner [mm]
	real            tx0, ty0
c                       Echelle Format coordinates of one corner [mm]
	real            tx1, ty1
C       Internal Variables
c                       Echelle Format coordinates [m]
	real            ex0, ey0, ex1, ey1
c                       chip coordinates [pixel]
	real            dpx, dpy, dpx0, dpy0, dpx1, dpy1
c                       loop
	integer         idet
C       Common Blocks
	include 'setup.inc'
	include 'detmos.inc'
	include 'spgraf.inc'
C       Executable Code
c       Convert to Detector Mosaic coordinates
	ex0 = (tx0 - posmos(Xp,0)) * mPERmm
	ey0 = (ty0 - posmos(Yp,0)) * mPERmm
	ex1 = (tx1 - posmos(Xp,0)) * mPERmm
	ey1 = (ty1 - posmos(Yp,0)) * mPERmm
c       search all chips for insidedness
	do 1000 idet=1,nchips
c         NOTE:  In the general case, proper determination of the
c         readout region of the chip would require full-blown polygon
c         clipping of the rubber-box to the detector limits.
c         The full general case is NOT treated here, but a simpler
c         method which works by finding the bounding box of the
c         rubberbox and using that as the readout limits.
c         This will result in readout windows which are slightly larger
c         than absolutely necessary, and this error is worse for cases
c         where the detectors are rotated wrt the Echelle Format.
	  dpx0 = tmc(Xp,Xo,M2C,idet)*ex0 + tmc(Xp,Yo,M2C,idet)*ey0
	  dpy0 = tmc(Yp,Xo,M2C,idet)*ex0 + tmc(Yp,Yo,M2C,idet)*ey0
	  dpx1 = dpx0
	  dpy1 = dpy0
	  dpx = tmc(Xp,Xo,M2C,idet)*ex1 + tmc(Xp,Yo,M2C,idet)*ey0
	  dpy = tmc(Yp,Xo,M2C,idet)*ex1 + tmc(Yp,Yo,M2C,idet)*ey0
	  dpx0 = min(dpx0,dpx)
	  dpy0 = min(dpy0,dpy)
	  dpx1 = max(dpx1,dpx)
	  dpy1 = max(dpy1,dpy)
	  dpx = tmc(Xp,Xo,M2C,idet)*ex1 + tmc(Xp,Yo,M2C,idet)*ey1
	  dpy = tmc(Yp,Xo,M2C,idet)*ex1 + tmc(Yp,Yo,M2C,idet)*ey1
	  dpx0 = min(dpx0,dpx)
	  dpy0 = min(dpy0,dpy)
	  dpx1 = max(dpx1,dpx)
	  dpy1 = max(dpy1,dpy)
	  dpx = tmc(Xp,Xo,M2C,idet)*ex0 + tmc(Xp,Yo,M2C,idet)*ey1
	  dpy = tmc(Yp,Xo,M2C,idet)*ex0 + tmc(Yp,Yo,M2C,idet)*ey1
	  dpx0 = min(dpx0,dpx) + tmc(Xp,To,M2C,idet)
	  dpy0 = min(dpy0,dpy) + tmc(Yp,To,M2C,idet)
	  dpx1 = max(dpx1,dpx) + tmc(Xp,To,M2C,idet)
	  dpy1 = max(dpy1,dpy) + tmc(Yp,To,M2C,idet)
c         clip all readout regions so they do not extend beyond detector edges
	  dpx0 = max(dpx0,0.)
	  dpy0 = max(dpy0,0.)
	  dpx1 = min(dpx1,npix(idet,Xp)+.9)
	  dpy1 = min(dpy1,npix(idet,Yp)+.9)
c         set the window limits
	  window(Xo,idet) = dpx0
	  window(Yo,idet) = dpy0
	  window(dX,idet) = dpx1 - window(Xo,idet)
	  window(dY,idet) = dpy1 - window(Yo,idet)
	  if (window(dX,idet) .le. 0 .or. window(dY,idet) .le. 0) then
c             not a valid window, set to nothing
	      window(Xo,idet) = 0
	      window(Yo,idet) = 0
	      window(dX,idet) = 0
	      window(dY,idet) = 0
c         else
c             write(*,*)'winlim',window(Xo,idet),window(Yo,idet),
c    &        window(dX,idet),window(dY,idet)
	  endif
1000    continue
	return
	end
C==============================================================================
C==============================================================================
	subroutine writform
c       Write out a file containing a description of the echelle format.
c       This is usually done after the program has been used for
c       designing a new spectrograph.
	IMPLICIT_NONE
C       Parameters
#       include "echelle.par"
C       Internal Variables
	integer         i
C       Common Blocks
	include 'echord.cmn'
	include 'spgraf.inc'
	include 'schott.cmn'
	include 'setup.inc'
C       Executable Code
c       Open the file into which the format is output.
	open(EFOLUN,file='format.out',form='formatted',
     &  status=StatNew CarriageControlList )
	write(EFOLUN,'(10x,a,/)')
     &  'ORDER SEPARATIONS, LOCATIONS, AND LENGTHS'
	write(EFOLUN,'(8x,a,f7.2,/)')
     &  'ECHELLE:    grooves/mm =', ecsigmai
	write(EFOLUN,'(20x,a,f5.1,6x,a,f4.1,/)')
     &  'Blaze Angle =', ecdeltad, 'Theta =', ecthetad
	write(EFOLUN,'(8x,a,f6.4,a)')
     &  'DIAMETERS:   Collimated Beam =', colldiam, ' m'
	write(EFOLUN,'(21x,a,f6.2,a,/)')
     &  'Telescope =', primdiam, '  m'
	write(EFOLUN,'(8x,a,f6.4,a)')
     &  'Collimator Focal Length =', colfocln, ' m'
	write(EFOLUN,'(8x,a,f7.4,a,/)')
     &  'Camera Focal Length =', camfocln, ' m'
	if (nxdprism .gt. 0) then
	    write(EFOLUN,'(8x,a)') 'PRISM CROSS DISPERSION'
	    write(EFOLUN,'(8X,A6,a,I2,a,f6.2,a)') typeg,' glass   ',
     &      nxdprism,' prisms at ',prapexd(0), ' degrees'
	endif
	if (nxdgrat .gt. 0) then
	    write(EFOLUN,'(8x,a)') 'GRATING CROSS DISPERSION'
	    write(EFOLUN,'(8x,a,f5.0,a,i2//)')
     &      'GRATING:     ', xdsigmai, ' G/mm      ORDER =', mc
	endif
	write(EFOLUN,*)
	write(EFOLUN,'(a)') ' Order Blaze(A)  FSR(A) DEL(mm) '//
     &  ' DEL(asec) HEIGHT(mm)  LENGTH(mm) DISP(A/mm)'
	write(EFOLUN,'(i5,f9.1,f8.1,f8.3,f10.3,f11.3,f10.2,f10.2)')
     &  (morder(i), wv(i), fsr(i), delx(i),
     &  phi(i), x(i,mc), f2db(i), fsr(i)/f2db(i), i=1,norders)
	close(EFOLUN)
	return
	end
C==============================================================================
C==============================================================================
	subroutine newprism(index)
c       fill in new values for prism parameters when one is changed
	IMPLICIT_NONE
C       Parameters
#       include "echelle.par"
C       External Variables
c                       index into array of changeable spgraf parameters
	integer         index
C       Internal Variables
c                       loop
	integer         i
C       Common Blocks
	include 'spgraf.inc'
C       Executable Code
	if (index .eq. i_PRAPEXD .or. index .eq. i_NXDPRISM) then
c           change all of the apex angles
	    do 121 i = 1,nxdprism
	      prapexd(i) = prapexd(0)
121         continue
	endif
	if (index .eq. i_PRGLAS  .or. index .eq. i_NXDPRISM) then
c           change all of the glass types
	    do 122 i = 1,nxdprism
	      prglas(i) = prglas(0)
122         continue
	endif
	if (index .eq. i_PRFACE  .or. index .eq. i_NXDPRISM) then
c           change all of the angles between faces
	    do 123 i = 2,nxdprism
	      prface(i) = prface(1)
123         continue
	endif
	return
	end
C==============================================================================
C==============================================================================
