#include "include/port.h"
C==============================================================================
#ifdef OLD_WAY
C==============================================================================
	integer function wkics(directory)
c       Open a file and write the configuration of a detector to that file.
c       using the KICS syntax.
	IMPLICIT_NONE
C       Parameters
#       include "include/stdio.par"
#       include "echelle.par"
C       External Variables
c                       the directory into which this setup should go
	character*(*)   directory
C       Internal Variables
c                       loop
	integer         i
c                       a place to read Conrad FITS string arrays
	character*132   string
c                       iostatus of an internal write
	integer         ios
c                       length of setup name
	integer         lsn
C       External Function
	integer         lenc
C       Common Block
	include 'setup.inc'
	include 'spgraf.inc'
	include 'detmos.inc'
	include 'lam.cmn'
C       Executable Code
c       BINNING   binning                                 array of integers[2]
c       CAFOCUS   camera-focus                            real number
c       COFOCUS   collimator-focus                        real number
c       COLL      collimator-select                       logical
c       DECKPOS   decker-position                         real number
c       DECKRAW   decker-raw-position                     integer
c       ECANGLE   echelle-angle                           real number
c       FILTER    filter-position                         integer
c       FILTER2   filter2-position                        integer
c       OBSERVER  observer                                ascii string
c       SLITWID   slit-width                              real number
c       SLITRAW   slit-raw-position                       integer
c       WINDOW    window                                  array of integers[5]
c       XDANGLE   cross-disperser-angle                   real number
c       open the file
	open(unit=EFOLUN,file=setup,status=StatNew,iostat=ios,
     &  form='formatted' CarriageControlList )
	if (ios .ne. SUCCESS) then
	    write(STDERR,*)
     &      'Could not open KICS file named'//setup
	endif
c       ----------------------------------------------------------------
	lsn = lenc(setup)
	string = 'define '//setup(:lsn)//' '
	lsn = lenc(string)+1
	i = lenc(observer)
	write(EFOLUN,*) string(:lsn)//'observer="'//observer(:i)//'"'
	write(EFOLUN,*) string(:lsn)//'ecangle=',ecangle
	if (nxdgrat .gt. 0)
     &  write(EFOLUN,*) string(:lsn)//'xdangle=',xdangle
c       special for the Hamilton Echelle spectrograph
c       if (nxdgrat .eq. 0 .and. nxdprism .eq. 2)
c    &  write(EFOLUN,*) string(:lsn)//'hamhgt=',nint(hamhgt)
c       ----------------------------------------------------------------
	write(EFOLUN,*) string(:lsn)//'deckpos=',deckpos
c       ----------------------------------------------------------------
	write(EFOLUN,*) string(:lsn)//'slitwid=',slitwid
c       ----------------------------------------------------------------
	write(EFOLUN,*) string(:lsn)//'filter=',filter
	write(EFOLUN,*) string(:lsn)//'filter2=',filter2
c       ----------------------------------------------------------------
	i = lenc(coll)
	write(EFOLUN,*) string(:lsn)//'coll= ',coll(:i)
	write(EFOLUN,*) string(:lsn)//'cofocus=',cofocus
	i = lenc(camera)
c       write(EFOLUN,*) string(:lsn)//'camera=',camera(:i)
	write(EFOLUN,*) string(:lsn)//'cafocus=',cafocus
c       ----------------------------------------------------------------
	write(EFOLUN,*) string(:lsn)//'binning="',
     &  xbin(0),',',ybin(0),'"'
	do 2500 i=1,nchips
	  write(EFOLUN,*) string(:lsn)//'window="',i,',',
     &    window(Xo,i),',',window(Yo,i),',',
     &    window(dX,i),',',window(dY,i),'"'
2500    continue
c       ----------------------------------------------------------------
c       close the file
	close(EFOLUN)
	return
	end
C==============================================================================
#else /* OLD_WAY */
C==============================================================================
	integer function wkics(directory)
c       Open a file and write the configuration of a detector to that file.
c       using the KICS syntax.
	IMPLICIT_NONE
C       Parameters
#       include "include/units.par"
#       include "include/stdio.par"
#       include "echelle.par"
C       External Variables
c                       the directory into which this setup should go
	character*(*)   directory
C       Internal Variables
c                       loop
	integer         i
c                       a place to read Conrad FITS string arrays
	character*256   string
c                       iostatus of an internal write
	integer         ios
C       External Function
	integer         lenc
C       Common Block
	include 'setup.inc'
	include 'spgraf.inc'
	include 'detmos.inc'
	include 'lam.cmn'
#       ifdef RATWIN
	include 'ratwin.cmn'
#       endif /* RATWIN */
C       Executable Code
c       open the file
	i = lenc(directory)
	if (i .gt. 0) then
	    string = directory
	endif
	string(i+1:) = setup
	open(unit=EFOLUN,file=string,status=StatNew,iostat=ios,
     &  form='formatted' CarriageControlList )
	if (ios .ne. SUCCESS) then
	    write(STDERR,*)
     &      'Could not open KICS file named '//setup
	endif
c       ----------------------------------------------------------------
	i = lenc(observer)
#       ifdef SOMEDAY
	write(EFOLUN,*) 'OBSERVER = "'//observer(:i)//'"'
#       endif /* SOMEDAY */
	write(EFOLUN,*) 'ECHANGL = ',ecangle
	if (nxdgrat .gt. 0)
     &  write(EFOLUN,*) 'XDANGL = ',xdangle
#       ifdef HAM_KICS
	/*
	 *  not useful until the Hamilton Echelle is driven by a variant
	 *  of the Keck Instrument Control System
	 */
	if (nxdgrat .eq. 0 .and. nxdprism .eq. 2)
     &  write(EFOLUN,*) 'HAMHGT = ',nint(hamhgt)
#       endif /* HAM_KICS */
c       ----------------------------------------------------------------
	write(EFOLUN,*) 'DECKNAME = ',decknnam
c       ----------------------------------------------------------------
	write(EFOLUN,*) 'SLITWID = ',slitwid
c       ----------------------------------------------------------------
c       write(EFOLUN,*) 'FIL1POS = ',filter
c       write(EFOLUN,*) 'FIL2POS = ',filter2
	write(EFOLUN,*) 'FIL1NAME= ',filname
	write(EFOLUN,*) 'FIL2NAME= ',fil2name
c       ----------------------------------------------------------------
	i = lenc(coll)
	write(EFOLUN,*) 'COLL = ',coll(:i)
	write(EFOLUN,'(a,f14.6)') 'COFOCUS = ',dble(cofocus)
	i = lenc(camera)
c       write(EFOLUN,*) 'CAMERA = ',camera(:i)
	write(EFOLUN,'(a,f14.6)') 'CAFOCUS = ',dble(cafocus)
c       ----------------------------------------------------------------
#       ifdef RATWIN
	call ratwindow
#       endif /* RATWIN */
	write(EFOLUN,*) 'BINNING = "',xbin(0),',',ybin(0),'"'
	write(EFOLUN,*) 'DWINDOW = "',1,',',
     &  window(Xo,0),',',window(Yo,0),',',
     &  window(dX,0),',',window(dY,0),'"'
#       ifdef RATWIN
	write(EFOLUN,*) 'WINDOW = "',1,',',
     &  kindow(Xo),',',kindow(Yo),',',
     &  kindow(dX),',',kindow(dY),'"'
#       endif /* RATWIN */
c       ----------------------------------------------------------------
c       close the file
	close(EFOLUN)
	return
	end
C==============================================================================
#endif  /* OLD_WAY */
C==============================================================================
