#include "include/port.h"
C==============================================================================
C==============================================================================
	integer function writdet(detfile)
c       Open a file and write the configuration of a detector to that file.
c       using FITS-card-like lines
	IMPLICIT_NONE
C       Parameters
#       include "include/stdio.par"
#       include "echelle.par"
	character*(*)   FMTLOG
	parameter       (FMTLOG = '(a,l20,a)')
	character*(*)   FMTINT
	parameter       (FMTINT = '(a,i20,a)')
	character*(*)   FMTSTR
	parameter       (FMTSTR = '(a,a,a)')
	character*(*)   FMTFP9
	parameter       (FMTFP9 = '(a,f20.9,a)')
	character*(*)   FMTBSPOT
	parameter       (FMTBSPOT = '(i6,4('','',i6))')
	character*(*)   FMTDETPOS
	parameter       (FMTDETPOS =
     &  '(2(f10.6,'',''),(f10.4,'',''),(i3,'',''),2(f10.3,'',''))')
C       External Variables
c                       the almost-FITS file containing the detector info
c                       which we will try to open and try to write
	character*(*)   detfile
C       Internal Variables
c                       loop
	integer         i, j
c                       a place to read Conrad FITS string arrays
	character*80    string
c                       iostatus of an internal write
	integer         ios
c                       a place to keep a dynamically created FITS keyword
	character*11    fitskey
c                       a place to keep a dynamically created format string
	character*4     ifmt
C       External Function
	integer         lenc
C       Common Block
	include 'detmos.inc'
C       Executable Code
	ifmt = '(i1)'
c       open the file
	open(unit=EFOLUN,file=detfile,status=StatNew,
     &  form='formatted',iostat=ios CarriageControlList )
	if (ios .ne. SUCCESS) return
	i = max(1,min(lenc(detector),MAXFITSTR))
	write(EFOLUN,FMTLOG) 'STDVIDV = '  ,stdvidv      ,'  /'
	write(EFOLUN,FMTLOG) 'STDVIDH = '  ,stdvidh      ,'  /'
	write(EFOLUN,FMTLOG) 'STDVIDR = '  ,stdvidr      ,'  /'
	write(EFOLUN,FMTSTR) 'DETECTOR= ''',detector(:i) ,''''
	write(EFOLUN,FMTINT) 'NCHIPS  = '  ,nchips       ,'  /'
	write(EFOLUN,FMTINT) 'XPIX    = '  ,npix(0,Xp)   ,'  /'
	write(EFOLUN,FMTINT) 'YPIX    = '  ,npix(0,Yp)   ,'  /'
	write(EFOLUN,FMTFP9) 'PIXXSZ  = '  ,pixsiz(0,Xp) ,'  /'
	write(EFOLUN,FMTFP9) 'PIXYSZ  = '  ,pixsiz(0,Yp) ,'  /'
c       ----------------------------------------------------------------
	do 1500 i=1,nchips
	  write(ifmt(3:3),'(i1)') int(log10(real(i))+1)
c
	  fitskey = 'CHIPID  = '''
	  write(fitskey(7:8),ifmt) i
	  j = max(1,min(lenc(chipid(i)),MAXFITSTR))
	  write(EFOLUN,FMTSTR)   fitskey, chipid(i)(:j) ,''''
c
	  fitskey = 'XPIX    = '
	  write(fitskey(5:8),ifmt) i
	  write(EFOLUN,FMTINT) fitskey(1:10), npix(i,Xp),'  /'
c
	  fitskey = 'YPIX    = '
	  write(fitskey(5:8),ifmt) i
	  write(EFOLUN,FMTINT) fitskey(1:10), npix(i,Yp),'  /'
c
	  fitskey = 'PIXXSZ  = '
	  write(fitskey(7:8),ifmt) i
	  write(EFOLUN,FMTFP9) fitskey(1:10),pixsiz(i,Xp),'  /'
c
	  fitskey = 'PIXYSZ  = '
	  write(fitskey(7:8),ifmt) i
	  write(EFOLUN,FMTFP9) fitskey(1:10),pixsiz(i,Yp),'  /'
c
	  fitskey = 'PHPRPX  = '
	  write(fitskey(7:8),ifmt) i
	  write(EFOLUN,FMTINT) fitskey(1:10),phprepix(i),'  /'
1500    continue
c       ----------------------------------------------------------------
	write(EFOLUN,FMTINT)   'NBSPOT  = ',nbspot,'  /'
c       ----------------------------------------------------------------
	fitskey = 'BSPOT   = '''
	do 2500 i=1,nbspot
	  write(ifmt(3:3),'(i1)') int(log10(real(i))+1)
	  write(fitskey(6:8),ifmt) i
	  string = ' '
	  write(string,FMTBSPOT) (bspot(j,i),j=cID,dY)
	  j = max(1,min(lenc(string),MAXFITSTR))
	  write(EFOLUN,FMTSTR)   fitskey, string(:j) ,''''
2500    continue
c       ----------------------------------------------------------------
	fitskey = 'DETPOS  = '''
	do 3500 i=1,nchips
	  write(ifmt(3:3),'(i1)') int(log10(real(i))+1)
	  write(fitskey(7:8),ifmt) i
	  string = ' '
	  write(string,FMTDETPOS)
     &    (detpos(j,i),j=Xp,Rot), int(detpos(Orient,i)),
     &    (detpos(j,i),j=RpX,RpY)
	  j = max(1,min(lenc(string),MAXFITSTR))
	  write(EFOLUN,FMTSTR)   fitskey, string(:j) ,''''
3500    continue
c       ----------------------------------------------------------------
c       close the file
	close(EFOLUN)
	return
	end
C==============================================================================
C==============================================================================
