#include "include/port.h"
C==============================================================================
C==============================================================================
	integer function writset(setfile)
c       Open a file and write the configuration of a detector to that file.
c       using FITS-card-like lines
	IMPLICIT_NONE
C       Parameters
#       include "include/stdio.par"
#       include "echelle.par"
C       External Variables
c                       the almost-FITS file containing the setup info
c                       which we will try to open and try to write
	character*(*)   setfile
C       Internal Variables
c                       loop
	integer         i, j
c                       a place to read Conrad FITS string arrays
	character*80    string
c                       iostatus of an internal write
	integer         ios
c                       a place to keep a dynamically created FITS keyword
	character*11    fitskey(3)
c                       a place to keep a dynamically created format string
	character*4     ifmt
c                       a dummy
	doubleprecision dummy
C       External Function
	integer         lenc
C       Common Block
	include 'setup.inc'
	include 'spgraf.inc'
	include 'detmos.inc'
	include 'lam.cmn'
#       ifdef RATWIN
	include 'ratwin.cmn'
#       endif /* RATWIN */
C       Executable Code
c       open the file
	open(unit=EFOLUN,file=setfile,form='formatted',iostat=ios,
     &  status=StatNew CarriageControlList )
	if (ios .ne. SUCCESS) return
c       ----------------------------------------------------------------
	i = max(1,min(lenc(detfilnm),MAXFITSTR))
	write(EFOLUN,'(a,a,a)')     'DETFILNM= ''',detfilnm(:i) ,''''
	i = max(1,min(lenc(spcfilnm),MAXFITSTR))
	write(EFOLUN,'(a,a,a)')     'SPCFILNM= ''',spcfilnm(:i) ,''''
c       ----------------------------------------------------------------
	i = max(1,min(lenc(setup),MAXFITSTR))
	write(EFOLUN,'(a,a,a)')     'SETUP   = ''',setup(:i)    ,''''
	i = max(1,min(lenc(observer),MAXFITSTR))
	write(EFOLUN,'(a,a,a)')     'OBSERVER= ''',observer(:i) ,''''
	write(EFOLUN,'(a,f20.6,a)') 'ECHANGL = '  ,ecangle      ,'  /'
	if (nxdgrat .gt. 0)
     &  write(EFOLUN,'(a,f20.6,a)') 'XDANGL  = '  ,xdangle      ,'  /'
c       special for the Hamilton Echelle spectrograph
	if (nxdgrat .eq. 0 .and. nxdprism .eq. 2)
     &  write(EFOLUN,'(a,f20.0,a)') 'HAMHGT  = '  ,hamhgt       ,'  /'
c       ----------------------------------------------------------------
	i = min(lenc(decker),MAXFITSTR)
	write(EFOLUN,'(a,i20,a)')   'DECKRAW = '  ,deckraw      ,'  /'
	write(EFOLUN,'(a,f20.6,a)') 'DECKPOS = '  ,deckpos      ,'  /'
	i = max(1,min(lenc(decknnam),MAXFITSTR))
	write(EFOLUN,'(a,a,a)')     'DECKNAME= ''',decknnam(:i) ,''''
c       next three are written in order of increasing importance
	write(EFOLUN,'(a,f20.3,a)') 'DECKPIX = '  ,deckpix      ,'  /'
	write(EFOLUN,'(a,f20.3,a)') 'DECKSIZE= '  ,decksize     ,'  /'
	write(EFOLUN,'(a,f20.6,a)') 'DECKHGT = '  ,deckhgt      ,'  /'
	if (ndeckap .gt. 0) then
	    string = ' '
	    write(string,'(i4,4('','',f9.6))') ndeckap,
     &      (deckspec(i),i=1,2*ndeckap)
	    i = max(1,min(lenc(string),MAXFITSTR))
	    write(EFOLUN,'(a,a,a)') 'DECKSPEC= ''',string(:i)   ,''''
	endif
c       ----------------------------------------------------------------
c       these are written in order of increasing importance
	write(EFOLUN,'(a,f20.3,a)') 'SLITVEL = '  ,slitvel      ,'  /'
	write(EFOLUN,'(a,f20.3,a)') 'SLITPIX = '  ,slitpix      ,'  /'
	write(EFOLUN,'(a,f20.3,a)') 'SLITSIZE= '  ,slitsize     ,'  /'
	write(EFOLUN,'(a,i20,a)')   'SLITRAW = '  ,slitraw      ,'  /'
	write(EFOLUN,'(a,f20.6,a)') 'SLITWID = '  ,slitwid      ,'  /'
c       ----------------------------------------------------------------
	write(EFOLUN,'(a,i20,a)')   'FIL1POS = ',filter         ,'  /'
	write(EFOLUN,'(a,i20,a)')   'FIL2POS = ',filter2        ,'  /'
	i = max(1,min(lenc(filname),MAXFITSTR))
	write(EFOLUN,'(a,a,a)')     'FIL1NAME= ''',filname(:i)  ,''''
	i = max(1,min(lenc(fil2name),MAXFITSTR))
	write(EFOLUN,'(a,a,a)')     'FIL2NAME= ''',fil2name(:i) ,''''
c       ----------------------------------------------------------------
	i = max(1,min(lenc(coll),MAXFITSTR))
	write(EFOLUN,'(a,a,a)')     'COLL    = ''',coll(:i)     ,''''
	write(EFOLUN,'(a,f20.6,a)') 'COFOCUS = '  ,cofocus      ,'  /'
	i = max(1,min(lenc(camera),MAXFITSTR))
	write(EFOLUN,'(a,a,a)')     'CAMERA  = ''',camera(:i)   ,''''
	write(EFOLUN,'(a,f20.6,a)') 'CAFOCUS = '  ,cafocus      ,'  /'
c       ----------------------------------------------------------------
c       ----------------------------------------------------------------
#       ifdef RATWIN
	call ratwindow
#       endif /* RATWIN */
	write(EFOLUN,'(a,i9,a,i9,a)')
     &  'BINNING = ''', xbin(0), ',', ybin(0), ''' /'
	string = ' '
	write(string,'(i6,4('','',i6))') (window(j,0),j=Xo,dY)
	j = max(1,min(lenc(string),MAXFITSTR))
	write(EFOLUN,'(a,a,a)')
     &  'DWINDOW = ''', string(:j)   ,''''
#       ifdef RATWIN
	string = ' '
	write(string,'(i6,4('','',i6))') (kindow(j),j=Xo,dY)
	j = max(1,min(lenc(string),MAXFITSTR))
	write(EFOLUN,'(a,a,a)')
     &  'WINDOW  = ''', string(:j)   ,''''
#       endif /* RATWIN */
	ifmt = '(i1)'
	fitskey(1) = 'BINNING = '''
	fitskey(2) = 'DWINDOW = '''
	do 2500 i=1,nchips
c         create the format used to create the numbered keyword
	  write(ifmt(3:3),'(i1)') int(log10(real(i))+1)
c         write the BINNINGn
	  write(fitskey(1)(8:8),ifmt) i
	  string = ' '
	  write(string,'(i6,1('','',i6))') xbin(i), ybin(i)
	  j = max(1,min(lenc(string),MAXFITSTR))
	  write(EFOLUN,'(a,a,a)')   fitskey(1)    ,string(:j)  ,''''
c         write the DWINDOWn
	  write(fitskey(2)(7:8),ifmt) i
	  string = ' '
	  write(string,'(i6,4('','',i6))') (window(j,i),j=Xo,dY)
	  j = max(1,min(lenc(string),MAXFITSTR))
	  write(EFOLUN,'(a,a,a)')   fitskey(2)    ,string(:j)   ,''' /'
2500    continue
c       ----------------------------------------------------------------
c       ----------------------------------------------------------------
	i = max(1,min(lenc(wavefile),MAXFITSTR))
	write(EFOLUN,'(a,a,a)')     'WAVEFILE= ''',wavefile(:i) ,''''
	write(EFOLUN,'(a,f20.6,a)') 'RADVELZ = '  ,redshift     ,'  /'
	dummy = (redshift + 1)**2
	dummy = cLIGHT * (dummy - 1) / (dummy + 1)
	write(EFOLUN,'(a,f20.3,a)') 'RADVEL  = '  ,dummy        ,'  /'
	write(EFOLUN,'(a,f20.4,a)') 'WAVLMAX = '  ,wl           ,'  /'
	write(EFOLUN,'(a,f20.4,a)') 'WAVLMIN = '  ,ws           ,'  /'
	write(EFOLUN,'(a,i20,a)')   'XDORDER = '  ,mc           ,'  /'
c       ----------------------------------------------------------------
c       close the file
	close(EFOLUN)
	return
	end
C==============================================================================
C==============================================================================
