#include "include/port.h"
C==============================================================================
C==============================================================================
	integer function writspc(spcfile)
c       Open a file and write the configuration of a spectrograph to that file.
c       using FITS-card-like lines
	IMPLICIT_NONE
C       Parameters
#       include "include/stdio.par"
#       include "echelle.par"
c                       a quote
	character*(1)   q
	parameter       (q = '''')
C       External Variables
c                       the almost-FITS file containing the spectrograph info
c                       which we will try to open and try to write
	character*(*)   spcfile
C       Internal Variables
c                       loop
	integer         i, j
c                       a place to store a fits key word
	character*10    fitskey(3)
c                       iostatus of an internal write
	integer         ios
C       External Function
	integer         lenc
C       Common Block
	include 'spgraf.inc'
C       Executable Code
c       open the file
	open(unit=EFOLUN,file=spcfile,form='formatted',iostat=ios,
     &  status=StatNew CarriageControlList )
	if (ios .ne. SUCCESS) return
	i = max(1,min(lenc(telescop),MAXFITSTR))
	write(EFOLUN,'(a,a)')       'TELESCOP= ',q//telescop(:i)//q
	i = max(1,min(lenc(instrume),MAXFITSTR))
	write(EFOLUN,'(a,a)')       'INSTRUME= ',q//instrume(:i)//q
	write(EFOLUN,'(a,f20.4,a)') 'PRIMDIAM= ',primdiam,'  /'
	write(EFOLUN,'(a,f20.6,a)') 'FOCSCALE= ',focscale,'  /'
	write(EFOLUN,'(a,f20.3,a)') 'COLFOCLN= ',colfocln,'  /'
	write(EFOLUN,'(a,f20.3,a)') 'CAMFOCLN= ',camfocln,'  /'
	write(EFOLUN,'(a,f20.3,a)') 'ECTHETAD= ',ecthetad,'  /'
	write(EFOLUN,'(a,f20.5,a)') 'ECDELTAD= ',ecdeltad,'  /'
	write(EFOLUN,'(a,f20.3,a)') 'ECSIGMA = ',ecsigma ,'  /'
	write(EFOLUN,'(a,f20.3,a)') 'ECSIGMAI= ',ecsigmai,'  /'
	i = max(1,min(lenc(xdispers),MAXFITSTR))
	write(EFOLUN,'(a,a)')       'XDISPERS= ',q//xdispers(:i)//q
	write(EFOLUN,'(a,i20,a)')   'NXDGRAT = ',nxdgrat ,'  /'
	if (nxdgrat .gt. 0) then
	    write(EFOLUN,'(a,f20.5,a)') 'XDDELTAD= ',xddeltad,'  /'
	    write(EFOLUN,'(a,f20.5,a)') 'XDALFBET= ',xdalfbet,'  /'
	    write(EFOLUN,'(a,f20.3,a)') 'XDSIGMA = ',xdsigma ,'  /'
	    write(EFOLUN,'(a,f20.3,a)') 'XDSIGMAI= ',xdsigmai,'  /'
	endif
	write(EFOLUN,'(a,i20,a)')   'NXDPRISM= ',nxdprism,'  /'
	if (nxdprism .gt. 0) then
	    write(EFOLUN,'(a,f20.5,a)') 'PRANGIND= ',prangind
	    write(EFOLUN,'(a,f20.5,a)') 'PRAPEX  = ',prapexd(0)
	    write(EFOLUN,'(a,a)')       'PRGLAS  = ',q//prglas(0)(:6)//q
	    fitskey(1) = 'PRAPEX  = '
	    fitskey(2) = 'PRGLAS  = '
	    fitskey(3) = 'PRFACE  = '
	    do 1000 i=1,nxdprism
	      do 500 j=1,3
		write(fitskey(j)(7:7),'(i1)') i
500           continue
	      write(EFOLUN,'(a,f20.5,a)')fitskey(1)    ,prapexd(i)
	      write(EFOLUN,'(a,a)')      fitskey(2), q//prglas(i)(:6)//q
	      write(EFOLUN,'(a,f20.5,a)')fitskey(3)    ,prface(i)
1000        continue
	endif
	write(EFOLUN,'(a,l20,a)')   'STDECHFH= ',stdechfh,'  /'
	write(EFOLUN,'(a,f20.3,a)') 'FPROTANG= ',fprotang,'  /'
c       ----------------------------------------------------------------
c       close the file
	close(EFOLUN)
	return
	end
C==============================================================================
C==============================================================================
