
;+
; NAME:
;   automated_oscan
;
; PURPOSE:
; Procedure that computes the bias using the overscan
;
;    
; CALLING SEQUENCE:
;
; INPUTS:
;   
; chips - the full cdd (image+oscan)
; 
; 
; OPTIONAL INPUTS:
;  
; 
; OUTPUTS: 
;
; dataimage - return the data only (oscan trimmed)
;
; OPTIONAL OUTPUTS:
;   
; COMMENTS:
;
; EXAMPLES:
;
; BUGS:
;
; PROCEDURES CALLED:
;
; REVISION HISTORY:
;    05-Jun-2012  Written and revised by MF
;
;-
;------------------------------------------------------------------------------
;; 

pro automated_oscan, chips, dataimage
 
  dataimage=make_array(2048,2048,/float)
  
  ;;run over the chip
  
  data=reform(chips[50:2097,1:2048])
  
  ;;get bias info
  overscan=reform(chips[2105:2195,1:2048])
  
  bia=djs_median(overscan,1)
  bias=rebin(transpose(bia),2048,2048)
  
  dataimage=data-bias
  
end
