;+
; NAME:
;   long_pltobj
;
; PURPOSE:
;  Simple routine which plots a spectrum after reading in the standard
;  science file generated by long_reduce
;
; CALLING SEQUENCE:
;
; INPUTS:
;
;
; OPTIONAL INPUTS:
;
; OUTPUTS:
;
; OPTIONAL OUTPUTS:
;
; COMMENTS:
;
; EXAMPLES:
;
; BUGS:
;
; PROCEDURES CALLED:
;   x_specplot (XIDL)
;
; INTERNAL SUPPORT ROUTINES:
;
; REVISION HISTORY:
;   01-Oct-2005  Written by J. Hennawi UC Berkeley
;------------------------------------------------------------------------------
pro long_pltobj, scifile, BRIGHT=bright, OBJID=objid, BOX=box

  if  N_params() LT 1  then begin 
      print,'Syntax - ' + $
        'long_pltobj, scifile, /BRIGHT, OBJID= [v1.0]'
      return
  endif 

  if not keyword_set(OBJID) then objid = 1
  if not keyword_set(EXTEN) then exten = 5
  spec = xmrdfits(scifile, EXTEN,/sile)

  ;;  Which obj?
  if keyword_set(BRIGHT) then begin
      medf = djs_median(spec.flux_box,1)
      mx = max(medf,imx)
      objid = spec[imx].objid
  endif

  idx = where(spec.objid EQ objid)

  print, 'long_pltobj: Using object', objid, ' and index ', idx

  ;; Flux
  fx = spec[idx].flux_opt
  iv = spec[idx].ivar_opt
  wv = spec[idx].wave_opt
  if keyword_set(BOX) then begin
      fx = spec[idx].flux_box
      iv = spec[idx].ivar_box
      wv = spec[idx].wave_box
  endif
  sig = fx
  sig[*] = 0.
  gd = where(iv GT 0.)
  sig[gd] = 1./sqrt(iv[gd])
  x_specplot, fx, sig, wav=wv, inflg=4, /bloc

  return
END
