PRO TSPEC_DIFF_PROC, filenames, pixflatfile, illumflatfile $
                     , tset_slits, ZAP = ZAP $
                     , AB = AB, ivar_AB = ivar_AB, piximg = piximg $
                     , targdir = targdir, sky_AB = sky_AB $
                     , waveimg = waveimg, TELLURIC = TELLURIC, hdr = hdr_A $
                     , WVCHK = WVCHK
;, ivar_pos = ivar_pos, ivar_neg = ivar_neg $
IF NOT KEYWORD_SET(scatt_shift) THEN scatt_shift = 5L
;; This cuts will act like a bad pixel mask
minval = 0.7
maxval = 1.3

ordermask = tspec_ordermask(tset_slits, order_vec = order_vec)
ximg = long_slits2x(tset_slits)
dims = size(ordermask, /dimen)
nx = dims[0]
ny = dims[1]

; Read in science object files 
tspec_proc, filenames[0], img_A, ivar_A, hdr = hdr_A $
            , pixflatfile = pixflatfile, illumflatfile = illumflatfile
tspec_proc, filenames[1], img_B, ivar_B, hdr = hdr_B $
            , pixflatfile = pixflatfile, illumflatfile = illumflatfile
maskstack = lonarr(nx*ny, 2)
img_stack = fltarr(nx*ny, 2)
img_stack[*, 0] = img_A
img_stack[*, 1] = img_B
avg_sky =  djs_avsigclip(img_stack, 2, sigrej = 2.0, inmask = maskstack $
                         , outmask = outmask)
avg_sky = reform(avg_sky, nx, ny)
piximg = tspec_makescipix(avg_sky, tset_slits, pixset = pixset, chk = wvchk)
;; KLUDGE FOR NOW
waveimg = tspec_waveimg(piximg, ordermask, order_vec)

;waveimg = gnirs_waveimg(wpix_img, wpixhdr, tset_slits, piximg = piximg $
;                        , QAFILE = QAFILE, CHK = WVCHK)
;gnirs_reject_cr, a1, ivar_a1, a2, ivar_a2, tset_slits, piximg, ordermask $
;                 , cr_mask1 = cr_mask_a1, cr_mask2 = cr_mask_a2
;gnirs_reject_cr, b1, ivar_b1, b2, ivar_b2, tset_slits, piximg, ordermask $
;                 , cr_mask1 = cr_mask_b1, cr_mask2 = cr_mask_b2
;maskstack[*, 0] = (cr_mask_a1 EQ 0)
;maskstack[*, 1] = (cr_mask_a2 EQ 0)
;maskstack[*, 2] = (cr_mask_b1 EQ 0)
;maskstack[*, 3] = (cr_mask_b2 EQ 0)
;avg_sky =  djs_avsigclip(img_stack, 2, sigrej = 1.3, inmask = maskstack $
;                         , outmask = outmask)
;wpix_img = reform(avg_sky, nx, ny)
;print, "Wavelength calibration"
; Generate final wavelength calibration wavelength map 
;waveimg = gnirs_waveimg(wpix_img, wpixhdr, tset_slits, piximg = piximg $
;                        , QAFILE = QAFILE, CHK = WVCHK)
IF KEYWORD_SET(TELLURIC) THEN BEGIN
;   Read in Telluric files now
; Read in science object files 
tspec_proc, telluric[0], img_A, ivar_A, hdr = hdr_A $
            , pixflatfile = pixflatfile, illumflatfile = illumflatfile
tspec_proc, telluric[1], img_B, ivar_B, hdr = hdr_B $
            , pixflatfile = pixflatfile, illumflatfile = illumflatfile
maskstack = lonarr(nx*ny, 2)
img_stack = fltarr(nx*ny, 2)
img_stack[*, 0] = img_A
img_stack[*, 1] = img_B
avg_sky =  djs_avsigclip(img_stack, 2, sigrej = 2.0, inmask = maskstack $
                         , outmask = outmask)
avg_sky = reform(avg_sky, nx, ny)
ENDIF

;   First pass AB sky subtraction.  Also corrects for bias and dark counts
print, "  First pass AB sky subtraction"
AB = img_A-img_B
sig2_AB = (ivar_A GT 0)/(ivar_A + (ivar_A LE 0.0)) + $
          (ivar_B GT 0)/(ivar_B + (ivar_B LE 0.0)) 
ivar_AB = (sig2_AB GT 0.0)/(sig2_AB + (sig2_AB LE 0))
finalmask = (ivar_A GT 0) 
; ABBA inverse variance is needed for bspline fitting. Since we don't 
; want the objects in the ABBA bspline we use sky only noise for both 
; making the object pixels more likely to be rejected 
;; THIS IS ALL OUTDATED SINCE WE ARE NOT USING THE S/N WEIGHTS IN THE SKY
;; SUBTRACTION BECAUSE OF TOO MANY HOT PIXELS
;ivar_abba = (ordermask GT 0.0 AND ximg LE 0.5)*ivar_neg + $
;  (ordermask GT 0.0 AND ximg GT 0.5)*ivar_pos
sky_AB  = avg_sky
;   Mask out-of-order pixels
out_order = where(ordermask EQ 0)
ivar_AB[out_order] = 0.0
finalmask[out_order] = 0.0

RETURN
END
