#include "include/port.h"
C==============================================================================
C==============================================================================
	integer function readmen(ndir,dirs,fileroot,retstring)
C       ---------------------
c       A function which attempts to find a files called "*.tailend"
c       It searches for such files in the ndir directories dirs.
c       If it does find files, it writes the contents of the file to
c       the standard output along with index numbers.
c       It prompts the user to choose one of the options in the menu,
c       and returns the string which the user chose in retstring.
c       The function presumes that the files being viewed as a menu will
c       fit upon a single screen.
C       ---------------------
	IMPLICIT_NONE
C       ---------------------
C       Parameters
#       include "echelle.par"
#       include "include/stdio.par"
c                       max number of files we may match
	integer         MXMFIL
	parameter       (MXMFIL = 32)
C       ---------------------
C       External Variables
c                       number of different directories to search
	integer         ndir
c                       names of the directories
	character*(*)   dirs(ndir)
c                       the root name of the file to open and read
	character*(*)   fileroot
c                       the return value read from the chosen line of the file
	character*(*)   retstring
C       ---------------------
C       Internal Variables
c                       loop
	integer         i, k, l
c                       fortran I/O status
	integer         ios
c                       list of files which match fileroot
	character       files(MXMFIL)*(MXPATH)
c                       number of matches in each directory
	integer         nfil(0:MXMFIL)
c                       a character string entered by the user
	character*64    retstr
C       ---------------------
C       External Function
	integer         PMGO(lenc)
C       ---------------------
C       Executable Code
c       search the directories for matches
	nfil(0) = MXMFIL
	call findfiles(fileroot,ndir,dirs,nfil,files)
c       start the prompt
	write(STDERR,*) 'Choose one of the following by its number'
c       regurgitate the list of matches for the user
	l = 1
c       loop over all directories
	do 1000 i = 1,ndir
	  if (nfil(i) .gt. 0) write(STDERR,*) 'In dir ',dirs(i)(:65)
c         loop over all files in each directory
	  do 500 k = l,l+nfil(i)-1
	    write(STDERR,'(i3,1x,a)') k,files(k)(:60)
500       continue
	  l = l + nfil(i)
1000    continue
c       ask which one to use
2000    continue
	write(STDERR,PROMPT) 'Which one?  '
	call mx11gets(retstr)
	read(retstr,*,iostat=ios) readmen
	if (ios .ne. SUCCESS .or.
     &  readmen .lt. 1 .or. readmen .gt. nfil(0)) goto 2000
c       figure out which directory was associated with that file
	i = 1
	l = nfil(i)
3000    continue
	if (readmen .gt. l) then
	    i = i + 1
	    l = l + nfil(i)
	    goto 3000
	endif
	l = PMGO(lenc)(dirs(i))
c       stuff that line into the return string
	retstring = dirs(i)(:l)//'/'//files(readmen)
C       ---------------------
	return
	end
C==============================================================================
C==============================================================================
